#ifndef ENGINE_H
#define ENGINE_H

#include "common.h"
#include "Game.h"

class Engine
{
    private:
        enum states
        {
            MENU,
            GAME,

            NUM_STATES
        };
        int state;
        Game* game;
        bool running;
        void drawMenu();
        void handleMenuInput();
    public:
        Engine();
        ~Engine();

        void run();
};

#endif // ENGINE_H
