#include "EventManager.h"
#include "NPC.h"

EventManager::EventManager()
{
    //ctor
}

EventManager::~EventManager()
{
}

void EventManager::draw()
{
    TCODConsole::root->rect(START_X, START_Y, WIDTH, HEIGHT+1, true);
    int count=0;
    list<Message>::iterator it;
    for(it = messages.begin(); it!= messages.end(); it++)
    {
        count+=(*it).height;
        TCODConsole::root->printLeftRect(START_X, START_Y+HEIGHT-count, WIDTH, HEIGHT, TCOD_BKGND_NONE, (*it).s.c_str());
        if(count>HEIGHT)
            break;
    }
}
void EventManager::addCombatText(NPC* a, NPC* b, int dmg)
{
    stringstream ss("");
    if(a->isPlayer)
    {
        ss<<"You ";
        if(dmg == -1)
        {
            ss<<"miss the ";
        }
        else
        {
            ss<<"hit the ";
        }
        ss<<b->name;
        if(dmg == 0)
            ss<<" for no damage!";
        else if(dmg == -1)
            ss<<"!";
        else
            ss<<" for "<<dmg<<" damage!";
    }
    else
    {
        ss<<"The ";
        ss<<a->name;

        if(b->isPlayer)
        {
            if(dmg == -1)
                ss<<" misses you!";
            else if(dmg == 0)
                ss<<" hits you for no damage!";
            else
                ss<<" hits you for "<<dmg<<" damage!";
        }
        else
        {
            if(dmg == -1)
            {
                ss<<" misses the "<<b->name<<"!";
            }
            else
            {
                ss<<" hits the "<<b->name<<" for "<<dmg<<" damage!";
            }
        }
    }

    add(ss.str());
    if(b->die)
    {
        if(a->isPlayer)
            add("You have slain the "+b->name+"!");
        else if(!b->isPlayer)
            add("The "+b->name+" has been slain!");
    }
}
void EventManager::add(string s)
{
    Message m(s, TCODConsole::root->getHeightLeftRect(START_X, START_Y, WIDTH, HEIGHT, s.c_str()));
    if(messages.size()>=20)
    {
        messages.pop_back();
    }
    messages.push_front(m);
}
