#ifndef EVENTMANAGER_H
#define EVENTMANAGER_H

#include "common.h"

class NPC;

class EventManager
{
    public:
        struct Message
        {
            string s;
            int height;
            Message(string s, int height):
                s(s),
                height(height)
            {}
        };
    private:
        static const int START_X = 0;
        static const int WIDTH = 40;
        static const int START_Y = 44;
        static const int HEIGHT = 5;
        static const int MAX_MESSAGES = 20;
        list<Message> messages;
    public:
        EventManager();
        ~EventManager();
        void draw();
        void add(string s);
        void addCombatText(NPC* a, NPC* b, int dmg); //-1 for miss
};

#endif // EVENTMANAGER_H
